#include "rwmake.ch"        // indica que houve conversao
#include "TbiConn.ch"
#include "TbiCode.ch"

User Function WF_265A(_nOpcao)
           
/*------------------------------------------------------------------------------
 * Declaracao de variaveis utilizadas no programa atraves da funcao            *
 * SetPrvt, que criara somente as variaveis definidas pelo usuario,            *
 * identificando as variaveis publicas do sistema utilizadas no codigo         *
 * Incluido pelo exassistente de conversao do AP5 IDE                            *
 *-----------------------------------------------------------------------------*/
  
  conOut("Iniciando Funcao Pick List")

// PREPARE ENVIRONMENT EMPRESA "00" FILIAL "01" FUNNAME "JOBOK00COT" Tables "SA1", "SX6"
// A rotina acima tem como finalidade preparar o ambiente caso no se execute o workflow
// atravs de Menu

SetPrvt("OHTML,N_TERMINA,OPROCESS,CIND")
SetPrvt("CCHAVE,CFILTRO,eFaturamento,CPOVI,ACOND,AREGS_PROCESSADOS")
SetPrvt("NCOTACAO,LFORNENEW,NPOSFOR,NI,CEMAIL,AFORNEC")
SetPrvt("wvlr_tot")
SetPrvt("_NREC_ATUAL,_NI,NNUMEMAIL,NCOUNT,ITEM,_USER")
SetPrvt("TO,CC,BCC,SUBJ,SUBJECT,BODY")
SetPrvt("CODERETURN,CODETIMEOUT,")

/*-----------------------------------------------------------------------------+
 * Programa WF_265A ANTIGO EVENTO7  Jose Ricardo Bernardo  Data   08/05/2000*
 +-----------------------------------------------------------------------------+
 *Objetivo   *Emitir e-mail para faturamento solicitando emisso da N.F.       *
 *           *Disparado apos emisso de Pick List (Expedico)                  *
 *-----------------------------------------------------------------------------+
 * Uso       WorkFlow/AP5 - Evento Microsiga                                  *
 *-----------------------------------------------------------------------------+
 | Starting  |Ponto de Entrada                                                 |
 +-----------------------------------------------------------------------------+

 Recebimento de parametros
 Tipo de destinatario 	    0 - entrada via schedule
						    1 - retorno do fornecedor
						    6 - termino T I M E O U T
 posicao do usuario na cadeia de aprovadores  XX - posicao na cadeia
 Solicitacao de Compra - XXXXXX
*/

/*-----------------------------------------------------------------------------+
 * Constructor do Objeto Processo                                              *
 +-----------------------------------------------------------------------------*/

//novas definicoes
//oHtml:= TWFHTML:New('d:\workflow\fontes\pmoris\pmpedcom.htm')
//oHtml:SaveToFile(\\minhanet\aaaaa)
//oHtml:SendMail(server_smtp, conta, destino, cc, bcc, suib)
//oHtml:= TWFHTML:New('d:\workflow\fontes\pmoris\pmpedcom.htm')
//oHtml:SaveToFile(\\minhanet\aaaaa)
//oHtml:SendMail(server_smtp, conta, destino, cc, bcc, suib)

/*-----------------------------------------------------------------------------+
 * Primeira vez                                                                *
 +-----------------------------------------------------------------------------*/

if _nOpcao == Nil // entrada pelo schedule ou seja inicio de toda operacao
   oProcess:=TWFProcess():New("WF_265A","Impressao da Nota Fiscal")
   oProcess:NewTask('Inicio',"\workflow\evento\WF_265A.htm")
   oHtml   := oProcess:oHtml
   
   eFaturamento := 'faturamento@microsiga' // Definio de e-mail padro
   eCopia := 'financeiro@microsiga'
   
   DBSelectArea("SF2")
   DBSETORDER(1)
   DBSEEK(XFILIAL("SF2") + SD2->D2_DOC + SD2->D2_SERIE)
   nNFiscal := SF2->F2_DOC
   
   DBSelectArea("SA1")    // Seleciona Cliente
   DBSetOrder(1)
   DbSeek( xFilial("SA1") + SF2->F2_CLIENTE + SF2->F2_LOJA )
   //cEmail  := if(empty(SA1->A1_EMAIL), eFaturamento, SA1->A1_EMAIL)
   cEmail  := if(empty(SA1->A1_EMAIL), eFaturamento, eFaturamento)
         
   //Seta variaveis
   wf_codcli  := SF2->F2_CLIENTE        
   wf_lojacli := SF2->F2_LOJA    
   wf_mail    := cEmail    
   wf_vendedor:= SA1->A1_ULTCOM   
   wf_cliente := SA1->A1_NOME  
   wf_nota    := SF2->F2_DOC 
   _cNFiscal  := wf_nota
   _ccliente  := wf_cliente
   wf_nreduz  := SA1->A1_NREDUZ
   wf_endcli  := SA1->A1_END
   wf_baicli  := SA1->A1_BAIRRO
   wf_muncli  := SA1->A1_MUN
   wf_estcli  := SA1->A1_EST
   wf_cgccli  := SA1->A1_CGC
   wf_icrcli  := SA1->A1_INSCR
   wf_irmcli  := SA1->A1_INSCRM
       
   aItens  := {} 
   DBSelectArea("SD2")          // Seleciona SD2 - Itens de Venda de NF
   DbSetOrder(3)
   DBSEEK(XFILIAL("SD2") + SF2->F2_DOC + SF2->F2_SERIE)
   while !Eof() .and. SD2->D2_FILIAL == XFILIAL("SD2") .AND.;
                      SF2->F2_DOC + SF2->F2_SERIE == SD2->D2_DOC + SD2->D2_SERIE
         DbSelectArea("SB1")
         DBSEEK(XFILIAL("SB1") + SD2->D2_COD)
         aadd(aItens, {SD2->D2_ITEM   ,;   // 1
                       SD2->D2_COD    ,;   // 2
                       SB1->B1_DESC   ,;   // 3  
                       SD2->D2_UM     ,;   // 4                               
   	   	               SD2->D2_QUANT  ,;   // 5
                       SD2->D2_PRCVEN ,;   // 6
  	   	               SD2->D2_TOTAL  })   // 7
	   	 DbSelectArea("SD2")
	   	 dbskip()
   enddo            
   
      
   
   DBSelectArea("SE4")       // Seleciona SE4 - Condicoes de Pgto 
   DBSetOrder(1) 
   DbSeek( xFilial("SE4") + SF2->F2_COND )
   aCond := SE4->E4_Codigo + " - " + trim(SE4->E4_Descri)

   EnviaEmail()             
	   
       
//elseIf _nOpcao[1] == 6     //avisa que nao respondeu e mail	dentro do prazo
//  	   oProcess:NewTask('Time Out',"\workflow\evento\timeout.htm")
//	   oHtml:=oProcess:oHtml
//	   oHtml:ValByName("Titulo" ,"Usuario no respondeu e-mail")
//   	   oHtml:ValByName("numNF"  ,_cNFiscal)
//	   oHtml:ValByName("cliente",_ccliente)
//   	   _cUser = Subs(cUsuario,7,15)
//   	   oHtml:ValByName("usuario",_cUser)
//   	   subj := "NF"+ _cNFiscal + " por " + _ccliente
//	   oProcess:Start() 
//       WFSendMail()
//       WfScheduler({cEmpAnt,cFilAnt})
Endif

RETURN  //main                              

Static function EnviaEmail()
        wvlr_tot := 0
        
        //Cabecalho
        oHtml:ValByName("nNFiscal"  , SF2->F2_DOC)
        oHtml:ValByName("cSerie"    , SF2->F2_SERIE)
        oHtml:ValByName("codcli"    , SF2->F2_CLIENTE)
        oHtml:ValByName("cliente"   , SA1->A1_NOME)
        oHtml:ValByName("endereco"  , SA1->A1_END)
   	    oHtml:ValByName("municipio" , SA1->A1_MUN)
   	    oHtml:ValByName("estado"    , SA1->A1_EST)   	    
   	    oHtml:ValByName("cgc_cpf"   , SA1->A1_CGC)
   	    oHtml:ValByName("inscr_est" , SA1->A1_INSCR)
   	    oHtml:ValByName("inscr_ccm" , SA1->A1_INSCRM)
   	    oHtml:ValByName("cond_pgto" ,acond)
   	    
   	    //Itens
   	    oHtml:ValByName("it.it"      , {})
        oHtml:ValByName("it.codprod" , {})
        oHtml:ValByName("it.desc"    , {})
        oHtml:ValByName("it.um"      , {})
        oHtml:ValByName("it.qtd"     , {})
        oHtml:ValByName("it.vlruni"  , {})
       	oHtml:ValByName("it.vlrtot"  , {}) 
     	    
     	For nCount := 1 to Len(aItens)
        	aadd(oHtml:ValByName("it.it")     , aItens[ncount,1])
        	aadd(oHtml:ValByName("it.codprod"), aItens[ncount,2])
        	aadd(oHtml:ValByName("it.desc")   , aItens[ncount,3])  
        	aadd(oHtml:ValByName("it.um")     , aItens[ncount,4])
        	aadd(oHtml:ValByName("it.qtd")    , TRANSFORM( aItens[nCount,5] ,'@E 9999,999.99' ))
        	aadd(oHtml:ValByName("it.vlruni") , TRANSFORM( aItens[nCount,6] ,'@E 9999,999.99' ))
       	    aadd(oHtml:ValByName("it.vlrtot") , TRANSFORM( aItens[nCount,7] ,'@E 9999,999.99' ))
       	    wvlr_tot := wvlr_tot + aItens[nCount,7]
   	    Next
   	   	oHtml:ValByName("vlrtot",TRANSFORM( wvlr_tot,'@E 9999,999.99' ))
   	
    	// Start do WorkFlow
		_user := Subs(cUsuario,7,15)
		oProcess:ClientName(_user)
		oProcess:cTo       := cEmail
		oProcess:cCC       := eCopia
		subj := "Impressao da Nota Fiscal. Cliente - " + SA1->A1_NOME
		oProcess:cSubject  := subj
		//oProcess:Body    := Body do Processo
		//oProcess:bReturn := "U_WF_265A(1)"   // oProcess:CodeReturn :=
        //oProcess:bTimeOut := { { "U_WF_265A(6)", 1, 1, 0 } }		
		//oProcess:CodeTimeOut := { { "FuncaoTimeOut1", ddd, hh, mm } , ;
		//						   { "FuncaoTimeOut2", ddd, hh, mm } }
		oProcess:Start()               
		RastreiaWF("00001"+'.'+oProcess:fTaskID,"000001",'1011',"Faturamento Gerado pela NF: "+SF2->F2_DOC+" e pedido emisso")		
		WfSendMail()
	
RETURN
