#include "rwmake.ch"        //indica que houve conversao (ver p/ que serve isto)
#include "TbiConn.ch"
#include "TbiCode.ch"
                  
/*-----------------------------------------------------------------------------+
 * Programa  * WF_450A    Business Intelligence        * Data   05/05/2000   *
 *-----------------------------------------------------------------------------*
 *Objetivo   * Verificar situao de crdito do Cliente                        *
 *           * (C9_BLCRED="" possui crdito / C9_BLCRED="01"ou "04" nao possui *
 *           * Credito no liberado - email solicitando liberao de crdito   *
 *-----------------------------------------------------------------------------*
 * Uso       * WorkFlow/AP5 - Evento Microsiga                                 *
 *-----------------------------------------------------------------------------+
 * Restries| Workflow para Liberacao de credito e/ou Estoque                 *
 *           | (Credito nao liberado) e-mail pedindo liberacao de credito      *
 *           | (Sem estoque) e-mail pedindo aprovacao p/ geracao de OP ou      *
 *           |               inclusao automatica da solicitacao de compras     *
 *-----------------------------------------------------------------------------+
 | Starting  | Ponto de Entrada MTA410T                                        |
 +-----------------------------------------------------------------------------*/

User Function WF_450A(_nOpcao, oProc)

SetPrvt("OHTML,_lCreditOk,_lEstoq_Ok,_nOpcao")
SetPrvt("_cPedido,_cCliente,_aSCSemEst,_aOPSemEst,_lSemCredito,_cPedido")
SetPrvt("_nQtd,_cNumsc1,_cItemSc1,_csubject")
SetPrvt("wvlrtot")
SetPrvt("nCount,_user")
SetPrvt("cTO, cCC, cBCC, cSubject, cBody")

/*-----------------------------------------------------------------------------*
 * Inicializando rotina                                                        *
 *-----------------------------------------------------------------------------*/

if _nOpcao == Nil

   cC5_NUM := M->C5_NUM      // Retorna numero do P.V. posicionado

   DBSelectArea("SC9")       // Seleciona Liberacao de Pedido
   DBSetOrder(1)
   DBSeek( xFilial("SC9") + cC5_NUM )
  
   _cPedido   := SC9->C9_PEDIDO
   _cCliente  := SC9->C9_CLIENTE

   if !ChkCredi()            // Credito no liberado
      oProcess:=TWFProcess():New("000001","Crdito No Liberado")
      oProcess:NewTask('Inicio',"\workflow\EVENTO\WF_450A.htm")
      oHtml   := oProcess:oHtml

      DBSelectArea("SA1")              // Seleciona Cliente
      DBSetOrder(1)
      DBSeek( xFilial("SA1") + SC5->C5_CLIENTE )
      wa1_lc     := SA1->A1_LC         // Valor limite de credito
      wa1_venclc := SA1->A1_VENCLC     // Vencto limite de credito
      wa1_pricom := SA1->A1_PRICOM     // Data primeira compra
      wa1_ultcom := SA1->A1_ULTCOM     // Data ultima compra
      wa1_mcompra:= SA1->A1_MCOMPRA    // Valor da maior compra
      wa1_nrocom := SA1->A1_NROCOM     // Numero de compras realizadas
      wa1_saldup := SA1->A1_SALDUP     // Saldo de duplicatas em cliente
      wa1_salpedl:= SA1->A1_SALPEDL    // Saldo de pedidos liberados
      wa1_atr    := SA1->A1_ATR        // Valor dos atrasos
      wa1_matr   := SA1->A1_MATR       // Quantidade de dias de maior atraso
      wa1_vacum  := SA1->A1_VACUM      // Vendas no ano
      wa1_salped := SA1->A1_SALPED     // Saldo de pedidos
      wa1_titprot:= SA1->A1_TITPROT    // Qtde de titulos protestados
      wa1_dtultit:= SA1->A1_DTULTIT    // Data ultimo titulo protestado
      wa1_chqdevo:= SA1->A1_CHQDEVO    // Cheques devolvidos
      wa1_dtulchq:= SA1->A1_DTULCHQ    // Data do ultimo cheque devolvido
      wa1_saltemp:= SA1->A1_SALTEMP    // Saldo Temporario de Credito
      wa1_maidupl:= SA1->A1_MAIDUPL    // Valor da Maior Duplicata
      
      aItens  := {} 
      DBSelectArea("SC6")              // Seleciona SC6 - Itens de Pedidos de Venda
      DbSetOrder(1)
      DBSEEK(XFILIAL("SC6")+SC5->C5_NUM)
      while !Eof() .and. SC5->C5_NUM = SC6->C6_NUM
            aadd(aItens, { SC6->C6_ITEM            ,;   // 1 Numero do Item do Pedido
                           SC6->C6_PRODUTO         ,;   // 2 Codigo do Produto
                           Alltrim(SC6->C6_DESCRI) ,;   // 3 Descrio Auxiliar
                           SC6->C6_ENTREG          ,;   // 4 Data de Entrega
                           SC6->C6_UM              ,;   // 5 Unidade de Medida
     	                   SC6->C6_QTDVEN          ,;   // 6 Quantidade Vendida
                           SC6->C6_PRCVEN          ,;   // 7 Preco Unitario Liquido
                           SC6->C6_VALOR           })   // 8 Valor Total do Item
            dbskip()
	  enddo 

      DBSelectArea("SE4")              // Seleciona SE4 - Condicoes de Pagamento
      DBSetOrder(1) 
      DbSeek( xFilial("SE4") + SC5->C5_CONDPAG )

      DBSelectArea("SA3")             // Seleciona SA3 - Vendedores
      DBSetOrder(1) 
      DbSeek( xFilial("SA3") + SC5->C5_VEND1 )

      EnviaEmail()
  
   else                  // Credito liberado
      U_WF_455A()        // Rotina WF que verificar existencia de estoque
   endif


elseif _nOpcao == 1   // Retorno do vindo de Liberao de Crdito

   ConOut("Iniciando Retorno de Liber. Credito")
   _cAprovar := oProc:oHtml:RetByName('Aprovacao')
   _cC5_NUM  := oProc:oHtml:RetByName('C5_NUM')         // Numero do P.V.
   //_cCliente := oProc:oHtml:RetByName('codcli')
   _cCliente := oProc:oHtml:RetByName('C5_CLIENTE')     // Cliente
   _cC5_VEND1:= oProc:oHtml:RetByName('C5_VEND1')       // Codigo do Vendedor no P.V.
//   _cobs     := oProc:oHtml:RetByName('C5_OBS') 
   
   if oProc:oHtml:RetByName("Aprovacao") = "S"
      
      DBSelectArea("SC9")    // Seleciona Pedidos Liberados
      DBSetOrder(1)
      DBSeek( xFilial("SC9") + _cC5_NUM )
      while !Eof() .and. SC9->C9_PEDIDO = _cC5_NUM
	       if RecLock("SC9",.f.)  
	          SC9->C9_BLCRED := "  "
	          MSUNLOCK()         
       	   endif  
       	   DBSKIP()                              
      enddo  
      
      DBSelectArea("SC5")
      DBSetOrder(1)
      DBSeek( xFilial("SC5") + _cC5_NUM )
         
      RastreiaWF("00001"+'.'+oProc:fTaskID,"000001",'1002')   	 
      U_WF_455A()   // Chama Liberao de Estoque
      
   else             // Enviar e-mail para vendedor avisando da no aprovao do crdito
      
      email := 'vendedor@microsiga'   // email padro
      
      DBSelectArea("SA3")    // Seleciona SA3 - Vendedores
      DBSeek( xFilial("SA3") + _cC5_VEND1 )
      email  := if(empty(SA3->A3_EMAIL), email, SA3->A3_EMAIL)
      
      Reprovar_Credito(oProc)
   endif

elseif _nOpcao == 6     //avisa que nao respondeu e mail dentro do prazo 
	   oProcess:NewTask('Time Out',"\workflow\EVENTO\timeout.htm")
	   oHtml:=oProcess:oHtml
	   oHtml:RetByName("Titulo","Usuario no respondeu e-mail")
   	   oHtml:RetByName("numPed",_cPedido)
	   oHtml:RetByName("cliente",_ccliente)
   	   _cUser = Subs(cUsuario,7,15)
   	   oHtml:RetByName("usuario",_cUser)
   	   subj := "Pedido"+ _cPedido + " por " + _ccliente
	   oProcess:Start() 
 
        WFSendMail()
       //WfScheduler({cEmpAnt,cFilAnt})
endif

return   // Fim do programa

/*-----------------------------------------------------------------------------+
 * Programa  *ChkCredi    Geronimo Benedito Alves    Data   08/05/2000      *
 +-----------------------------------------------------------------------------+
 * Objetivo  *Verificar crdito do cliente(limite estourado ou vencido)        *
 *-----------------------------------------------------------------------------+
 * Parametros*  "  " - Credito Liberado                                        *
 *              "01" - Limite Vencido                                          *
 *              "04" - Limite Estourado                                        *
 *              "10" - Pedito Faturado                                         *
 +-----------------------------------------------------------------------------*/

static Function ChkCredi()
_lCreditOk := .T.              // .T. - Credito Liberado
                               // .F. - Credito Bloqueado
if SC9->C9_BLCRED == "  "
   _lCreditOk := .T.
else

   if SC9->C9_BLCRED == "01"
      _csubject := "Vencimento do limite de crdito "
   elseif SC9->C9_BLCRED == "04"
      _csubject := "Limite de crdito ultrapassado "
   elseif SC9->C9_BLCRED == "10"
      _csubject := "Pedido j Faturado "
   endif
   _lCreditOk := .F.
   
endif
return(_lCreditOk)

static function EnviaEmail()
    
    wvlrtot := 0    
    
    dbSelectArea("SC5")
    RecLock("SC5")
    SC5->C5_WFID := "00001"
    MsUnlock()
                    
    oHtml:valbyname("c5_num"    , SC5->C5_NUM)
    oHtml:valbyname("c5_cliente", SC5->C5_CLIENTE)
    oHtml:valbyname("a1_nome"   , SA1->A1_NOME)
    oHtml:valbyname("a1_end"    , SA1->A1_END)
    oHtml:valbyname("a1_mun"    , SA1->A1_MUN)
    oHtml:valbyname("a1_est"    , SA1->A1_EST)   	    
    oHtml:valbyname("a1_cgc"    , SA1->A1_CGC)
    oHtml:valbyname("a1_inscr"  , SA1->A1_INSCR)
    oHtml:valbyname("a1_inscrm" , SA1->A1_INSCRM)
    oHtml:valbyname("c5_condpag", trim(SC5->C5_CONDPAG))
    oHtml:valbyname("e4_descri" , trim(SE4->E4_DESCRI))
    oHtml:valbyname("c5_vend1"  , SC5->C5_VEND1)
    oHtml:valbyname("a3_nome"   , SA3->A3_NOME)  
    
    For nCount := 1 to Len(aItens)
        aadd(oHtml:valbyname("it.it")     , aItens[nCount,1])  
        aadd(oHtml:valbyname("it.codprod"), aItens[nCount,2])  
        aadd(oHtml:valbyname("it.desc")   , aItens[nCount,3]) 
        aadd(oHtml:valbyname("it.prev")   , aItens[nCount,4]) 
        aadd(oHtml:valbyname("it.um")     , aItens[nCount,5])  
        aadd(oHtml:valbyname("it.qtd")    , TRANSFORM( aItens[nCount,6] ,'@E 9999,999.99' ))
        aadd(oHtml:valbyname("it.vlruni") , TRANSFORM( aItens[nCount,7] ,'@E 9999,999.99' ))
        aadd(oHtml:valbyname("it.vlrtot") , TRANSFORM( aItens[nCount,8] ,'@E 9999,999.99' ))
        wvlrtot := wvlrtot + aItens[nCount,8] 
    Next
    
    oHtml:valbyname("vlrtot"    ,TRANSFORM(wvlrtot    ,'@E 9999,999.99'))
    oHtml:valbyname("a1_lc"     ,TRANSFORM(wa1_lc     ,'@E 9999,999.99'))
    oHtml:valbyname("a1_saldup" ,TRANSFORM(wa1_saldup ,'@E 9999,999.99'))
    oHtml:valbyname("a1_salpedl",TRANSFORM(wa1_salpedl,'@E 9999,999.99'))
    wvlrsaldo = wa1_lc - wa1_saldup
    oHtml:valbyname("a1_sallim" ,TRANSFORM(wvlrsaldo  ,'@E 9999,999.99'))
    oHtml:valbyname("a1_saltemp",TRANSFORM(wa1_saltemp,'@E 9999,999.99'))
    oHtml:valbyname("a1_pedatu" ,TRANSFORM(wvlrtot    ,'@E 9999,999.99'))
    oHtml:valbyname("a1_salped" ,TRANSFORM(wa1_salped ,'@E 9999,999.99'))
    oHtml:valbyname("a1_pricom" ,wa1_pricom)
    oHtml:valbyname("a1_nrocom" ,TRANSFORM(wa1_nrocom ,'@E 9999,999.99'))
    oHtml:valbyname("a1_dtultit",wa1_dtultit)
    oHtml:valbyname("a1_titprot",TRANSFORM(wa1_titprot,'@E 9999,999.99'))
    oHtml:valbyname("a1_chqdevo",TRANSFORM(wa1_chqdevo,'@E 9999,999.99'))
    oHtml:valbyname("a1_mcompra",TRANSFORM(wa1_mcompra,'@E 9999,999.99'))
    oHtml:valbyname("a1_maidupl",TRANSFORM(wa1_maidupl,'@E 9999,999.99'))
    oHtml:valbyname("a1_atr"    ,TRANSFORM(wa1_atr    ,'@E 9999,999.99'))
    oHtml:valbyname("a1_venclc" ,wa1_venclc)
    oHtml:valbyname("a1_matr"   ,wa1_matr )
    oHtml:valbyname("a1_ultcom" ,wa1_ultcom)
    oHtml:valbyname("a1_vacum"  ,TRANSFORM(wa1_vacum  ,'@E 9999,999.99'))
    oHtml:valbyname("a1_dtulchq",wa1_dtulchq)
//    oHtml:valbyname("c5_obs"    , " ")
            
    _user := Subs(cUsuario,7,15)
    oProcess:ClientName(_user)
    oProcess:cTo      := 'cobranca@microsiga' // Definio de e-mail padro       
    //oProcess:cCC      := 'lucianax@lucianax'
    oProcess:cBCC     := ''
    oProcess:cSubject := "Solicitao de Crdito - Cliente " + SC5->C5_CLIENTE + "  " + SA1->A1_NOME
    oProcess:cBody    := ""
    oProcess:bReturn  := "U_WF_450A(1)"
//    oProcess:bTimeOut := { { "U_WF_450A(6)", 1, 1, 0 } }

   	oProcess:Start() 
	RastreiaWF("00001"+'.'+oProcess:fTaskID,oProcess:fProcCode,'1001')   	
    oProcess:Free()
    oProcess:= Nil
       
    WFSendMail()
return

static function Reprovar_Credito(oProcess)
      
    _user := Subs(cUsuario,7,15)
    oProcess:ClientName(_user)
    oProcess:cTo      := email
    oProcess:cCC      := "" 
    oProcess:cBCC     := ""
    oProcess:cSubject := "Rejeio de Crdito para Pedido de Venda em anexo" 
    
    oProcess:cBody    := ""                     
    oProcess:bReturn  := ""
    oProcess:bTimeOut := ""

    oProcess:Start()
    oProcess:Finish()
        
    WFSendMail()
return
