#include "rwmake.ch"        
#include "TbiConn.ch"
#include "TbiCode.ch"

/*-----------------------------------------------------------------------------+
 * Programa  * W1881502     Business Inteligence         * Data   26/09/2000 *
 *-----------------------------------------------------------------------------*
 * Objetivo  * Programa que envia e-mail para aprovao de um Pedido de Compra *
 *           * a partir de um Ponto de Entrada chamado WFW120P.                * 
 *-----------------------------------------------------------------------------*
 * Uso       * WorkFlow/AP5 - VideoLar                                         *
 *-----------------------------------------------------------------------------+
 | Starting  | Ponto de Entrada                                                |
 +-----------------------------------------------------------------------------*/

User Function MT130WF(oProcess)
     
     Local aCond:={}, aFrete:= {}, aSubst:={}, nTotal := 0
	 Local _cC8_NUM, _cC8_FORNECE, _cC8_LOJA
     Local _cEmlFor
     
     dbSelectArea("SC8")  
     dbSetOrder(1)
     dbSeek(xFilial("SC8")+ParamIXB[1])
     while !eof() .and. xFilial("SC8")+ParamIXB[1]==C8_FILIAL+C8_NUM
                             
        _cC8_NUM     := SC8->C8_NUM
        _cC8_FORNECE := SC8->C8_FORNECE
        _cC8_LOJA    := SC8->C8_LOJA

	    dbSelectArea('SA2')  // Tabela de Fornecedores
	    dbSetOrder(1)
	    dbSeek( xFilial('SA2') + _cC8_FORNECE + _cC8_LOJA )
		_cEmlFor := SA2->A2_EMAIL
        if Alltrim(_cEmlFor) <> ""
              
           oProcess := TWFProcess():New( "000002", "Cotao de Preos" )
   	       oProcess :NewTask( "Fluxo de Compras", "\WORKFLOW\EVENTO\COTACAO.HTM" )
  	       oHtml    := oProcess:oHTML
	    
	       dbSelectArea('SC8')  // Cotacoes
	       dbSetOrder(1)
	       dbSeek( xFilial('SC8') + _cC8_NUM + _cC8_FORNECE + _cC8_LOJA )
           oHtml:ValByName( "C8_CONTATO" , SC8->C8_CONTATO  )

           PswOrder(1)
           if PswSeek(cUsuario,.t.)
              aInfo    := PswRet(1)   
              _cUser   := aInfo[1,2]
           endIf

           /*** Preenche os dados do cabecalho ***/
           oHtml:ValByName( "C8_NUM"    , SC8->C8_NUM     )
           oHtml:ValByName( "C8_VALIDA" , SC8->C8_VALIDA  )
           oHtml:ValByName( "C8_FORNECE", SC8->C8_FORNECE )
           oHtml:ValByName( "C8_LOJA"   , SC8->C8_LOJA    )
        
   	       dbSelectArea('SA2')  // Tabela de Fornecedores
   	       dbSetOrder(1)
	       dbSeek( xFilial('SA2') + _cC8_FORNECE + _cC8_LOJA )
	       oHtml:ValByName( "A2_NOME"   , SA2->A2_NOME   )
	       oHtml:ValByName( "A2_END"    , SA2->A2_END    )
	       oHtml:ValByName( "A2_MUN"    , SA2->A2_MUN    )
	       oHtml:ValByName( "A2_BAIRRO" , SA2->A2_BAIRRO )
	       oHtml:ValByName( "A2_TEL"    , SA2->A2_TEL    )
	       oHtml:ValByName( "A2_FAX"    , SA2->A2_FAX    )
           
//           RastreiaWF(Alltrim(oProcess:fProcessID) + '.' + oProcess:fTaskID,"000002",'30004','Cotao n ' + _cC8_NUM + " enviada para fornecedor " + SA2->A2_NOME, subst(cUsuario,7,15) )
           
           dbSelectArea("SE4")
           dbSetOrder(1)
           if dbSeek(xFilial("SE4") + SA2->A2_COND )
              aAdd( aCond, SE4->E4_Codigo + " - " + SE4->E4_Descri )
           endif
           dbGoTop()
           while !eof() .and. SE4->E4_Filial == xFilial("SE4")
              aAdd( aCond, SE4->E4_Codigo + " - " + SE4->E4_Descri )
              dbSkip()
           enddo
                         
//     	   _cEmlDest := U_BuscaEml(cUsuario) //Funcao que busca o email
	 
  	       dbSelectArea('SC8')  // Cotacoes
  	       dbSetOrder(1)
   	       dbSeek( xFilial('SC8') + _cC8_NUM + _cC8_FORNECE + _cC8_LOJA )
           oHtml:ValByName( "C8_CONTATO" , SC8->C8_CONTATO  )
         
           while !eof() .and. SC8->C8_FILIAL = xFilial("SC8") ;
                        .and. SC8->C8_NUM     = _cC8_NUM ;
                        .and. SC8->C8_FORNECE = _cC8_FORNECE ;
                        .and. SC8->C8_LOJA    = _cC8_LOJA 
                   
              aAdd( (oHtml:ValByName( "it.item"    )), SC8->C8_ITEM    )
              aAdd( (oHtml:ValByName( "it.produto" )), SC8->C8_PRODUTO )
                         
              dbSelectArea("SB1")
              dbSetOrder(1)
              dbSeek(xFilial("SB1") + SC8->C8_PRODUTO )
              aAdd( (oHtml:ValByName( "it.descri"  )), SB1->B1_DESC    ) // SC8->C8_DESCRI  )
 
              //aAdd( (oHtml:ValByName( "it.c8_descri"  )), SC8->C8_OBS     ) // SC8->C8_DESCRI  )
              aAdd( (oHtml:ValByName( "it.quant"   )), TRANSFORM( SC8->C8_QUANT,'@E 99,999.99' ) )
              aAdd( (oHtml:ValByName( "it.um"      )), SC8->C8_UM      )
              aAdd( (oHtml:ValByName( "it.preco"   )), TRANSFORM( 0.00,'@E 99,999.99' ) )
              aAdd( (oHtml:ValByName( "it.valor"   )), TRANSFORM( 0.00,'@E 99,999.99' ) )
              aAdd( (oHtml:ValByName( "it.prazo"   )), " ")
              aAdd( (oHtml:ValByName( "it.ipi"     )), TRANSFORM( 0.00,'@E 99,999.99' ) )
              aAdd( (oHtml:ValByName( "it.dia"     )), str(day(SC8->C8_DATPRF))         )
              aAdd( (oHtml:ValByName( "it.mes"     )), padl( alltrim( str( month(SC8->C8_DATPRF) ) ),2,"0") )
              aAdd( (oHtml:ValByName( "it.ano"     )), right(str(year(SC8->C8_DATPRF)),2))
              dbSelectArea("SC8")
              RecLock('SC8')
                 C8_WFID := oProcess:fProcessID
              MsUnlock()
              dbSkip()
           enddo
           oHtml:ValByName( "Pagamento", aCond    )
           oHtml:ValByName( "Frete"    , {"CIF","FOB"}   )
           oHtml:ValByName( "subtot"   , TRANSFORM( 0 ,'@E 999,999.99' ) )
           oHtml:ValByName( "vldesc"   , TRANSFORM( 0 ,'@E 999,999.99' ) )
           oHtml:ValByName( "aliipi"   , TRANSFORM( 0 ,'@E 999,999.99' ) )
           oHtml:ValByName( "valfre"   , TRANSFORM( 0 ,'@E 999,999.99' ) )
           oHtml:ValByName( "totped"   , TRANSFORM( 0 ,'@E 999,999.99' ) )
  
     	   oProcess:cSubject := "Processo de gerao de Cotao de Preos " + _cC8_NUM
     	   oProcess:cTo      := _cEmlFor
  	       oProcess:bReturn  := "U_W1881503(1)"
	       oProcess:Start() 
		   RastreiaWF("00001"+'.'+oProcess:fTaskID,"000001",'1003',"Email Enviado Para o Fornecedor:"+SA2->A2_NOME)   		       
	       WFSendMail()
	       WFSendMail()	       
        else
           // Atualizar SC8 para nao processar novamente
           dbSelectArea("SC8")
           RecLock('SC8')  
              SC8->C8_WFID := "WF9999" 
           MsUnlock()      
           dbSkip()
        endif
     enddo   


/*-----------------------------------------------------------------------------+
 * Programa  * W1881503    Business Inteligence         * Data   29/09/2000  *
 *-----------------------------------------------------------------------------*
 *Objetivo   * Programa executado durante retorno de cotacoes preenchidas      *
 *             fornecedores,                                                   *
 *-----------------------------------------------------------------------------*
 * Uso       * WorkFlow/AP5 - WorkFlow                                         *
 *-----------------------------------------------------------------------------+
 | Starting  | Rotina de Retorno no Processo de WorkFlow                       |
 +-----------------------------------------------------------------------------*/

User Function W1881503(AOpcao, oProcess) 

    if ValType(aOpcao) = "A" 
       aOpcao := aOpcao[1]
    endif   
        
    if aOpcao == NIL
	   aOpcao := 0          
	endIf

    if aOpcao == 1  
       _cC8_NUM     := oProcess:oHtml:RetByName("C8_NUM"     )
       _cC8_FORNECE := oProcess:oHtml:RetByName("C8_FORNECE" )
       _cC8_LOJA    := oProcess:oHtml:RetByName("C8_LOJA"    )
    endif

    dbSelectArea("SC8")
    dbSetOrder(1)
    dbSeek( xFilial("SC8") + Padr(_cC8_NUM,6) + Padr(_cC8_FORNECE,6) + _cC8_LOJA )

    if oProcess:oHtml:RetByName("Aprovacao") = "S"   // Cotacao Recebida
      
	   RastreiaWF("00001"+'.'+oProcess:fTaskID,"000001",'1004',"Email respondido pelo Fornecedor:"+_cC8_FORNECE)   		       
       _cC8_VLDESC := oProcess:oHtml:RetByName("VLDESC" )
       _cC8_ALIIPI := oProcess:oHtml:RetByName("ALIIPI" )
       _cC8_VALFRE := oProcess:oHtml:RetByName("VALFRE" )

       if oProcess:oHtml:RetByName("Frete") = "FOB" 
          _cC8_RATFRE := 0
       else
          // (Qtd * Unitario)\Total * Vlr. Frete
          //_cC8_RATFRE := _cC8_VALFRE / len(oProcess:oHtml:RetByName("it.preco"))
       endif
       
//       RastreiaWF(Alltrim(oProcess:fProcessID) + '.' + oProcess:fTaskID,"000002",'30005','Atualizao da Cotao n ' + _cC8_NUM , subst(cUsuario,7,15) )
        
       for _nind := 1 to len(oProcess:oHtml:RetByName("it.preco"))
       
           _cC8_ITEM := oProcess:oHtml:RetByName("it.item")[_nind]    
           dbSelectArea("SC8")
           dbSetOrder(1)
           dbSeek( xFilial("SC8") + Padr(_cC8_NUM,6) + Padr(_cC8_FORNECE,6) + _cC8_LOJA + _cC8_ITEM )
           RecLock("SC8",.f.)
              SC8->C8_PRECO  := Val(oProcess:oHtml:RetByName("it.preco")[_nind])
              SC8->C8_TOTAL  := Val(oProcess:oHtml:RetByName("it.valor")[_nind])              
              SC8->C8_ALIIPI := Val(oProcess:oHtml:RetByName("it.ipi"  )[_nind])
              SC8->C8_PRAZO  := Val(oProcess:oHtml:RetByName("it.prazo")[_nind])  
              _C8_DATPRF     :=     oProcess:oHtml:RetByName("it.dia"  )[_nind] + "/" + ;
                                    oProcess:oHtml:RetByName("it.mes"  )[_nind] + "/" + ;
                                    oProcess:oHtml:RetByName("it.ano"  )[_nind] 
              SC8->C8_DATPRF := CTOD(_C8_DATPRF)
              SC8->C8_COND   := Substr(oProcess:oHtml:RetByName("pagamento"),1,3)
              SC8->C8_TPFRETE:= Substr(oProcess:oHtml:RetByName("Frete"),1,1)
              
              iif( oProcess:oHtml:RetByName("Frete") = "FOB", ;
                   SC8->C8_VALFRE := 0, ;
                   SC8->C8_VALFRE := Val(oProcess:oHtml:RetByName("it.quant")[_nind]) * ;
                                     Val(oProcess:oHtml:RetByName("it.preco")[_nind]) / ;
                                     Val(oProcess:oHtml:RetByName("totped") ) *         ;
                                     Val(oProcess:oHtml:RetByName("valfre") ) )

              iif( Val(oProcess:oHtml:RetByName("vldesc")) == 0 ,;
                   SC8->C8_VLDESC := 0, ;
                   SC8->C8_VLDESC := Val(oProcess:oHtml:RetByName("it.quant")[_nind]) * ;
                                     Val(oProcess:oHtml:RetByName("it.preco")[_nind]) / ;
                                     Val(oProcess:oHtml:RetByName("totped") ) * ;
                                     Val(oProcess:oHtml:RetByName("vldesc") ) )

           MsUnlock()
       next
    endif

Return
