#include "rwmake.ch"        // indica que houve conversao
#include "TbiConn.ch"
#include "TbiCode.ch"

User Function WF_MERC(_nOpcao)
           
/*------------------------------------------------------------------------------
 * Declaracao de variaveis utilizadas no programa atraves da funcao            *
 * SetPrvt, que criara somente as variaveis definidas pelo usuario,            *
 * identificando as variaveis publicas do sistema utilizadas no codigo         *
 * Incluido pelo exassistente de conversao do AP5 IDE                          *
 *-----------------------------------------------------------------------------*/
  
  conOut("Iniciando Funcao de Embarque da Mercadoria")

// PREPARE ENVIRONMENT EMPRESA "00" FILIAL "01" FUNNAME "JOBOK00COT" Tables "SA1", "SX6"
// A rotina acima tem como finalidade preparar o ambiente caso no se execute o workflow
// atravs de Menu

SetPrvt("OHTML,N_TERMINA,OPROCESS,CIND")
SetPrvt("CCHAVE,CFILTRO,eFaturamento,CPOVI,ACOND,AREGS_PROCESSADOS")
SetPrvt("NCOTACAO,LFORNENEW,NPOSFOR,NI,CEMAIL,AVEND, AFORNEC")
SetPrvt("wTrans,wEnd_Trans,wMun_Trans,wEst_Trans")
SetPrvt("wvlr_tot") 
SetPrvt("_NREC_ATUAL,_NI,NNUMEMAIL,NCOUNT,ITEM,_USER,VLRTOT")
SetPrvt("TO,CC,BCC,SUBJ,SUBJECT,BODY")
SetPrvt("CODERETURN,CODETIMEOUT,")

/*-----------------------------------------------------------------------------+
 * Programa WF_MERC - ANTIGO EVENTO8 Jose Ricardo Bernardo  Data  08/05/2000 *
 +-----------------------------------------------------------------------------+
 *Objetivo   *Emitir e-mail para vendedor sobre entrega do material aps       *
 *           *embarque da mercadoria                                           *
 *-----------------------------------------------------------------------------+
 * Uso       WorkFlow/AP5 - Evento Microsiga                                  *
 *-----------------------------------------------------------------------------+
 | Starting  |                                                                 |
 +-----------------------------------------------------------------------------+

 Recebimento de parametros
 Tipo de destinatario 	    0 - entrada via schedule
						    1 - retorno do fornecedor
						    6 - termino T I M E O U T
 posicao do usuario na cadeia de aprovadores  XX - posicao na cadeia
 Solicitacao de Compra - XXXXXX
*/

/*-----------------------------------------------------------------------------+
 * Constructor do Objeto Processo                                              *
 +-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------+
 * Primeira vez                                                                *
 +-----------------------------------------------------------------------------*/
IF Pergunte("WFENTR",.T.)
	if _nOpcao == Nil // entrada pelo schedule ou seja inicio de toda operacao
	   oProcess:=TWFProcess():New("WF_MERC","Embarque de Mercadoria")
	   oProcess:NewTask('Inicio',"\workflow\evento\WF_MERC.htm")
	   oHtml   := oProcess:oHtml
	   
	   eVendedor := 'vendedor@microsiga;cliente@microsiga' // Definio de e-mail padro
	                                       
	   DBSelectArea("SF2")
	   DbsetOrder(1)
	   DbSeek(xFilial("SF2") + mv_par01)
	   While !EOF() .and. SF2->F2_FILIAL == XFILIAL("SF2") .AND. SF2->F2_DOC >= MV_PAR01 .AND.;
	                      SF2->F2_SERIE >= MV_PAR03 .AND. SF2->F2_DOC <= MV_PAR02 .AND.;
	                      SF2->F2_SERIE <= MV_PAR04
		   numNF := SF2->F2_DOC
		    
		   DBSelectArea("SA1")    // Seleciona Cliente
		   DBSetOrder(1)
		   DbSeek( xFilial("SA1") + SF2->F2_CLIENTE + SF2->F2_LOJA )
		   
		   //Seta variaveis
		   wvlr_total := 0
		   wf_codcli  := SF2->F2_CLIENTE        
		   wf_lojacli := SF2->F2_LOJA    
		   wf_mail    := cEmail    
		   wf_vendedor:= SF2->F2_VEND1   
		   wf_cliente := SA1->A1_NOME  
		   wf_pedido  := SF2->F2_DOC 
		   _cpedido   := wf_pedido
		   _ccliente  := wf_cliente
		   wf_nreduz  := SA1->A1_NREDUZ
		   wf_endcli  := SA1->A1_END
		   wf_baicli  := SA1->A1_BAIRRO
		   wf_muncli  := SA1->A1_MUN
		   wf_estcli  := SA1->A1_EST
		   wf_cgccli  := SA1->A1_CGC
		   wf_icrcli  := SA1->A1_INSCR
		   wf_irmcli  := SA1->A1_INSCRM
		   wf_vlrbrt  := SF2->F2_VALBRUT 	
		  	                                      
		   aItens  := {} 
		   DBSelectArea("SD2")          // Seleciona SD2 - Itens de Venda de NF
		   DbSetOrder(3)
		   DBSEEK(XFILIAL("SD2") + SF2->F2_DOC + SF2->F2_SERIE)
		   while !Eof() .and. SD2->D2_FILIAL == XFILIAL("SD2") .AND.;
		                      SF2->F2_DOC + SF2->F2_SERIE == SD2->D2_DOC + SD2->D2_SERIE
		         DbSelectArea("SB1")
		         DBSEEK(XFILIAL("SB1") + SD2->D2_COD)
		         aadd(aItens, {SD2->D2_ITEM   ,;   // 1
		                       SD2->D2_COD    ,;   // 2
		                       SB1->B1_DESC   ,;   // 3  
		                       SD2->D2_UM     ,;   // 4                               
		   	   	               SD2->D2_QUANT  ,;   // 5
		                       SD2->D2_PRCVEN ,;   // 6
		  	   	               SD2->D2_TOTAL  })   // 7
			   	 DbSelectArea("SD2")
			   	 dbskip()
		   enddo            
			   	 
		   wvlr_total := wvlr_total + SD2->D2_TOTAL
		   
		   DBSelectArea("SE4")       // Seleciona Condies de Pagamento
		   DBSetOrder(1)
		   DbSeek( xFilial("SE4") + SF2->F2_COND )
		   aCond := SE4->E4_Codigo + " - " + trim(SE4->E4_Descri)
		
		   DBSelectArea("SA3")       // Seleciona Vendedores
		   DBSetOrder(1)
		   DbSeek( xFilial("SA3") + SF2->F2_VEND1 )
		   aVend := SA3->A3_COD + " - " + trim(SA3->A3_Nome)
		   //cEmail  := if(empty(SA3->A3_EMAIL), eVendedor, SA3->A3_EMAIL)
		   cEmail  := if(empty(SA3->A3_EMAIL), eVendedor, eVendedor)
		   
		   DBSelectArea("SA4")       // Seleciona Transportadoras
		   DBSetOrder(1)
		   DbSeek( xFilial("SA4") + SF2->F2_TRANSP )
		   wTrans     := SA4->A4_COD + " - " + trim(SA4->A4_Nome)
		   wEnd_Trans := SA4->A4_END
		   wMun_Trans := SA4->A4_MUN
		   wEst_Trans := SA4->A4_EST
		   
		   EnviaEmail()	
		
	   DBSELECTAREA("SF2")
	   DBSKIP()	
	   ENDDO
	//elseIf _nOpcao[1] == 6     //avisa que nao respondeu e mail	dentro do prazo
	//       oProcess:NewTask('Time Out',"\workflow\evento\timeout.htm")
	//	   oHtml:=oProcess:oHtml
	//	   oHtml:ValByName("Titulo","Usuario no respondeu e-mail")
	//   	   oHtml:ValByName("numPed",_cPedido)
	//	   oHtml:ValByName("cliente",_ccliente)
	//   	   _cUser = Subs(cUsuario,7,15)
	//   	   oHtml:ValByName("usuario",_cUser)
	//   	   subj := "Pedido"+ _cPedido + " por " + _ccliente
	//	   oProcess:Start() 
	//       WFSendMail()
	//       WfScheduler({cEmpAnt,cFilAnt})
	Endif
ENDIF	
RETURN  //main                              
	
Static function EnviaEmail()
        wvlr_tot := 0
     
    	oHtml:ValByName("numNF"       ,SF2->F2_DOC)
    	oHtml:ValByName("Serie"       ,SF2->F2_SERIE)
    	oHtml:ValByName("codcli"      ,SF2->F2_CLIENTE)
   	    oHtml:ValByName("cliente"     ,SA1->A1_NOME)
   	    oHtml:ValByName("endereco"    ,SA1->A1_END)
   	    oHtml:ValByName("municipio"   ,SA1->A1_MUN)
   	    oHtml:ValByName("estado"      ,SA1->A1_EST)   	    
   	    oHtml:ValByName("cgc_cpf"     ,SA1->A1_CGC)
   	    oHtml:ValByName("inscr_est"   ,SA1->A1_INSCR)
   	    oHtml:ValByName("inscr_ccm"   ,SA1->A1_INSCRM)
   	    oHtml:ValByName("cond_pgto"   ,acond)
   	    
        oHtml:ValByName("it.it"      , {})
        oHtml:ValByName("it.codprod" , {})
        oHtml:ValByName("it.desc"    , {})
        oHtml:ValByName("it.um"      , {})
        oHtml:ValByName("it.qtd"     , {})
        oHtml:ValByName("it.vlruni"  , {})
       	oHtml:ValByName("it.vlrtot"  , {}) 
  
     	For nCount := 1 to Len(aItens)
        	aadd(oHtml:ValByName("it.it")     , aItens[ncount,1])
        	aadd(oHtml:ValByName("it.codprod"), aItens[ncount,2])
        	aadd(oHtml:ValByName("it.desc")   , aItens[ncount,3])
        	aadd(oHtml:ValByName("it.um")     , aItens[ncount,4])
        	aadd(oHtml:ValByName("it.qtd")    , TRANSFORM( aItens[nCount,5] ,'@E 9999,999.99' ))
        	aadd(oHtml:ValByName("it.vlruni") , TRANSFORM( aItens[nCount,6] ,'@E 9999,999.99' ))
       	    aadd(oHtml:ValByName("it.vlrtot") , TRANSFORM( aItens[nCount,7] ,'@E 9999,999.99' ))
   	        wvlr_tot := wvlr_tot + aItens[nCount,7]
   	    Next
   	   	oHtml:ValByName("vlrtotal",TRANSFORM( wvlr_tot,'@E 9999,999.99' ))
    
     	oHtml:ValByName("Trans",wTrans)
     	oHtml:ValByName("End_Trans",wEnd_Trans)
     	oHtml:ValByName("Mun_Trans",wMun_Trans)
     	oHtml:ValByName("Est_Trans",wEst_Trans)
     	     	     	     	
     	
       	// Start do WorkFlow
		_user := Subs(cUsuario,7,15)
		oProcess:ClientName(_user)
		oProcess:cTo       := cEmail
		subj := "Encaminhamento de Mercadoria. Cliente - "+SA1->A1_NOME
		oProcess:cSubject  := subj
		//oProcess:Body    := Body do Processo
		//oProcess:bReturn := "U_WF_MERC(1)"   // oProcess:CodeReturn :=
        //oProcess:bTimeOut := { { "U_WF_MERC(6)", 1, 1, 0 } }		
		//oProcess:CodeTimeOut := { { "FuncaoTimeOut1", ddd, hh, mm } , ;
		//						   { "FuncaoTimeOut2", ddd, hh, mm } }
		oProcess:Start()
		RastreiaWF("00001"+'.'+oProcess:fTaskID,"000001",'1012')		
		WfSendMail()
		MSGAlert("Vendedores e Clientes Avisados.")
RETURN
