/*-----------------------------------------------------------------------------+
 | Programa  |CHK_SC9  |    Business Inteligence          | Data   xx/xx/2000  |
 +-----------------------------------------------------------------------------+
 * Objetivo  * Verificar existncia de estoque p/ atender necessidade do pedido*
 +-----------------------------------------------------------------------------+
 * Observacao| C9_BLCEST     "  " - Existe Estoque                             *
 *           |               "02" - Limite Vencido                             *
 *           |               "10" - Pedido Faturado                            *
 +-----------------------------------------------------------------------------+
 * Parametros| _pc9_pedido -> numero do pedido  no SC9 - Liberao Cred./Est.  *
 *           | _pc9_produto-> codigo do produto no SC9 - Liberao Cred./Est.  *
 *           | _quant      -> qtde   do produto passado como parametro         *
 +-----------------------------------------------------------------------------+
 | Criado em | 05/06/2000 - Jose Ricardo Bernardo                              |
 +-----------------------------------------------------------------------------*/

User Function CHK_SC9(_pc9_pedido,_pc9_produto,pquant)

_lC9_BLCEST := .T.   // variavel que indica BLCEST - Bloqueio de Estoque
                     // .F. Bloqueado
                     // .T. Sem Bloqueio 
_nQtd       := 0                     

DBSelectArea("SC9")
DBSetOrder(1)
DBSeek( XFILIAL("SC9") + _pc9_pedido ) // confere se todos os produtos tem estoque
While !eof() .and. SC9->C9_PEDIDO == _pc9_pedido
      if SC9->C9_PRODUTO = _pc9_produto  
         if SC9->C9_BLEST  == "02"        // Produto sem estoque
            _lC9_BLCEST := .F.
            // Verificar Lote Economico e Lote Minimo no arquivo de produtos 
            DBSelectArea("SB1")
            DBSeek( XFILIAL("SB1") + SC9->C9_PRODUTO )
            _nQtd := SC9->C9_QTDLIB
            if (SC9->C9_QTDLIB >= SB1->B1_LE .and. SC9->C9_QTDLIB <= SB1->B1_LM) .or. SB1->B1_LM == 0 .and. SB1->B1_LE == 0
               _nQtd := SC9->C9_QTDLIB
            elseif  SC9->C9_QTDLIB <= SB1->B1_LM 
               _nQtd := SB1->B1_LM
            endif 
         elseif SC9->C9_BLEST  == "10"    // Item de Produto ja faturado
            _lC9_BLCEST := .F.
         endif
      endif
      DBSelectArea("SC9")
      DBskip()
enddo
return(_lC9_BLCEST)