/*-----------------------------------------------------------------------------+
 | Programa  |CHK_SG1  |    Business Inteligence          | Data   08/05/2000  |
 +-----------------------------------------------------------------------------+
 * Objetivo  * Verificar existncia de estoque para estrutura do produto       *
 *           * Se item da estrutura nao possuir estoque                        *
 *           *         gerar solicitacao de compra SC1 para suprir necessidade *
 *           * Seno                                                           *
 *           *         criar automaticamente solicitao de compras            *
 +-----------------------------------------------------------------------------+
 * Observacao| Efetua calculo somente para primeiro nivel da estrutura         *
 +-----------------------------------------------------------------------------+
 * Parametros| _pg1_cod  -> codigo do produto passado como parametro           *
 *           | _quant    -> qtde   do produto passado como parametro           *
 *           | _op_gerasc-> gerar solicitacao de compra para Ordem de Producao *
 *           |              True / False                                       * 
 +-----------------------------------------------------------------------------+
 | Criado em | 01/06/2000 - Jose Ricardo Bernardo                              |
 +-----------------------------------------------------------------------------*/

User Function CHK_SG1(_pg1_cod,_pquant,_op_gerasc)

_op_gerasc:= .F.

SetPrvt("_cItemSC1,_cNumsc1,_cItemSc1,_csubject")
SetPrvt("_pg1_cod, _pquant ,_op_gerasc")

_lg1_cod   := .F.   // variavel logica indica existencia de g1_cod

_mt110cab  := {}    // array contendo cabecalho para solicitacao de compra
_mt110item := {}    // array contendo itens     para solicitacao de compra

_user := Subs(cUsuario,7,15) // Usuario do sistema

DBSelectArea("SG1")                    // Seleciona SG1 - Arquivo de Estruturas
DBSetOrder(1)

// Ricardo - Verificar a existencia de um produto com varias estruturas diferentes.
// Se arquivo possuir estrutura verifica existencia de estoque para componente      

if DbSeek(xFilial("SG1") + _pg1_cod)
  ConOut("Achei a Estrutura")
  Return .T.
else                         
  ConOut("No Achei a Estrutura")
  Return .F.  
endif
ConOut("No tem que passar aqui")
if DbSeek(xFilial("SG1") + _pg1_cod)
   if SG1->G1_NIV = "99"
      _lg1_cod := .T.
   endif
   
//   Return(_lg1_cod)   
   if (SG1->G1_NIV <> "99") .and. _op_gerasc = .T.   // Rever rotina
      _lg1_cod := .T.
   endif
   wg1_cod  := SG1->G1_COD
   While !Eof() .and. SG1->G1_COD = wg1_cod
         wg1_comp := SG1->G1_COMP      // Componente
         wg1_quant:= SG1->G1_QUANT     // Qtde Empenhada na producao
         wg1_trt  := SG1->G1_TRT       // Sequencia da Estrutura
         
         DBSelectArea("SB1")           // Seleciona arquivo de produtos
         DBSetOrder(1)
         DBSeek(xFilial("SB1") + wg1_cod )

         DBSelectArea("SB2")           // Seleciona Saldos Fisicos
         DBSetOrder(1)
         DBSeek(xFilial("SB2") + wg1_cod )
         wB2_QATU   := SB2->B2_QATU    // Saldo Atual
         wB2_QEMP   := SB2->B2_QEMP    // Qtde Empenhada
         wB2_QPEDVEN:= SB2->B2_QPEDVEN // Qtde Pedido de Vendas
         wB2_RESERVA:= SB2->B2_RESERVA // Quantidade Reservada
         wB2_USAI   := SB2->B2_USAI    // Data da Ultima Saida
        
         if (wB2_QATU - wB2_QEMP) < 100 //(wg1_quant * wc6_qtdven) Ricardo
            cquant := 100 - wB2_QATU    // quantidade da solicitacao de compra
            montar_sc()                 // Montar array para solicitacao de compra MATA110
         endif
         DBSelectArea("SG1")            
         DBSkip()
   enddo
   
   if !empty(_mt110cab)   // _mt110cab
      lmsErroAuto := .F.
      msExecAuto({|X,Y|MATA110(X,Y)},_mt110cab,_mt110item) 
      if lMsErroAuto        // variavel do sigaauto indicando erro na operacao
         RollBackSX8()
      else
         ConfirmSX8()
      endif
   endif
endif
return(_lg1_cod)  

static function montar_sc
ConOut("Montar_SC")
if len(_mt110cab) == 0     // montar array de cabelhado para SC
   _cNumsc1  := GETSX8NUM("SC1","C1_NUM") // Substituido Ricardo
   _cItemSc1 := '01'
   aadd(_mt110cab ,{'C1_NUM'       , _cNumSc1            , nil })
   aadd(_mt110cab ,{'C1_EMISSAO'   , DDATABASE            , nil })      
else            
   _cItemSc1 := strzero( Val(_cItemSc1) +1 ,2)
endif
aadd(_mt110item ,{ {'C1_EMISSAO'   , DDATABASE           , nil } ,;
                   {'C1_ITEM'      ,_cItemSc1            , nil } ,;
                   {'C1_PRODUTO'   , SG1->G1_comp        , nil } ,;
                   {'C1_QUANT'     , cquant              , nil } ,;
                   {'C1_UM'        , SB1->B1_UM          , nil } ,;
                   {'C1_FORNECE'   , "1"                 , nil }} )
return